--
-- hayasgrass
-- 
-- 
--
-- oschuhm 01.07.2017

--[[
changelog:

05.07.2017:
according to the required namechange of the mod I also had to change the logic when we will do the replacement.
Script checks now regularly if hay is in grass group. If hay is missing in the group it will be added and removed from other groups.

]]

hayasgrass = {};
hayasgrass.hayInserted = false;

addModEventListener(hayasgrass);

function hayasgrass.prerequisitesPresent(specializations)
    return true;
end;

local function insertHay()

	-- Das ist jetzt der einfache Teil ... Heu in die Gruppe "Gras" eintrgaen
	FillUtil.registerFillTypeInFoodGroup(AnimalUtil.ANIMAL_COW, 1, FillUtil['FILLTYPE_DRYGRASS_WINDROW']);
	
	-- Damit wir Heu nicht doppelt füttern ... lesen wir die Futtergruppen der Kühe aus
	local cowGroups = FillUtil.foodGroups[AnimalUtil.ANIMAL_COW];
	--DebugUtil.printTableRecursively(cowGroups, "", 0, 100); -- dient nur zum deduggen
	
    if cowGroups ~= nil then
		for groupID, groupTable in pairs(cowGroups) do
			-- jetzt müssen wir für die Gruppe Bulk noch das "Heu" raus nehmen
			if (groupTable.groupName == 'bulk') then
				--print(cowGroups[groupID].groupName .. " gefunden");
				
				-- aktuelle Filltypes für Kühe Basisfutter auslesen die es auf der Map gibt
				local actualFillTypes = cowGroups[groupID].fillTypes;
				--DebugUtil.printTableRecursively(actualFillTypes, "", 0, 100); -- nur zum debuggen
				
				--Tabelle für die Bulk FillTypes leer machen
				cowGroups[groupID].fillTypes = {};
				
				for fillTypeID, fillTypeValue in pairs(actualFillTypes) do
					-- und jetzt tragen wir wieder alle Futtersorten ein ... ausser natürlich Heu
					if (fillTypeID ~= FillUtil['FILLTYPE_DRYGRASS_WINDROW']) then
						FillUtil.registerFillTypeInFoodGroup(AnimalUtil.ANIMAL_COW, 2, fillTypeID);
					end;
				end;
				
			end;
	    end;
	end;

	--jetzt noch schnell merken, dass wir das Heu schon eingetragen haben
	hayasgrass.hayInserted = true;
	
    --[[print("-- Kontrolle nachher");
	DebugUtil.printTableRecursively(FillUtil.foodGroups[AnimalUtil.ANIMAL_COW], "", 0, 100);
	print("-- Kontrolle nachher");
	--]]


end;

local function isHayInGrassGroup()

    -- Das ganze müssen wir nur machen, wenn Heu nicht schon eingetragen ist
	-- Ansonsten können wir direkt true für erledigt zurück geben
	if (hayasgrass.hayInserted == true) then
		return true;
	end;

	print("*-- hayasgrass MOD - Perform Check: This line should only appear once")
	
    -- Lesen wir mal die Futtergruppen der Kühe aus
	local cowGroups = FillUtil.foodGroups[AnimalUtil.ANIMAL_COW];
	--DebugUtil.printTableRecursively(cowGroups, "", 0, 100); -- dient nur zum deduggen
	
	local checkResult = false;
	
    if cowGroups ~= nil then
		for groupID, groupTable in pairs(cowGroups) do
			-- jetzt prüfen wir ob in der Gruppe "grass" auch Heu drin steht
			if (groupTable.groupName == 'grass') then
				
				-- aktuelle Filltypes für Kühe Gras auslesen die es auf der Map gibt
				local actualFillTypes = cowGroups[groupID].fillTypes;
				--DebugUtil.printTableRecursively(actualFillTypes, "", 0, 100); -- nur zum debuggen
				
				for fillTypeID, fillTypeValue in pairs(actualFillTypes) do
					-- und jetzt tragen wir wieder alle Futtersorten ein ... ausser natürlich Heu
					if (fillTypeID == FillUtil['FILLTYPE_DRYGRASS_WINDROW']) then
						checkResult = true;
					end;
				end;
				
			end;
	    end;
	end;

	return checkResult;

end;

function hayasgrass:loadMap(name)

	print("*-- hayasgrass:loadMap(name)");
	
	if (isHayInGrassGroup() == false) then 
	  print("*-- Try to insert hay into grass group during hayasgrass:draw - this should appear only once")
	  insertHay();
	end;

end;

function hayasgrass:loadMapFinished(name)

	print("*-- hayasgrass:loadMapFinished(name)")

end;

function hayasgrass:update(dt)
end;

function hayasgrass:deleteMap()
end;

function hayasgrass:loadXMLConfig()
end;

function hayasgrass:mouseEvent(posX, posY, isDown, isUp, button)
end;

function hayasgrass:keyEvent(unicode, sym, modifier, isDown)
end;

function hayasgrass:draw()
end;

